<?php
namespace Teknisa\PCP\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;

class DestinosSolicitacaoCheckListEmergencialController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "destsolemergprod_receitam_dsvoo";
    protected $destinosSolicitacaoService;

    public function __construct($crudService, $parameterBag, $destinosSolicitacaoService) {
        
        $this->destinosSolicitacaoService = $destinosSolicitacaoService;
        
        parent::__construct($crudService, $parameterBag);
        
    }

    public function save(Request $request, Response $response){
        
        parent::save($request, $response);
        
        $row = $request->getDataSet()->getRows()[0];
        self::setNewRecipeAmountAfterSaveNewRelatedDestination($row);
        
        $columnsToReturn = $this->crudService->getColumnsToReturn();
        	        
        $retorno = array();
        $retorno["QTDRECEITASUSADAS"] = $row["QTDRECEITASUSADAS"];
        
        if (count($columnsToReturn) > 0){
            $retorno["NRDESTSOLEMERGPROD"] = $columnsToReturn[0]["NRDESTSOLEMERGPROD"];
        }else{
            $retorno["NRDESTSOLEMERGPROD"] = $row['NRDESTSOLEMERGPROD'];
        }
        	           
        $response->addDataSet(new DataSet("columnsToReturn", $retorno));
        
    }
    
    public function delete(Request $request, Response $response){
        
        parent::delete($request, $response);
        
        $row = $request->getRow();
        self::setNewRecipeAmountAfterSaveNewRelatedDestination($row);
        
    }
    
    public function setNewRecipeAmountAfterSaveNewRelatedDestination($row){
        
        $row["QTDRECEITASUSADAS"] = self::getDestinationRecipeAmoutByRelatedRecipe($row);
        self::updateRecipeAmount($row);
        
    }
    
    public function getDestinationRecipeAmoutByRelatedRecipe($row){
        
        $selectParam = array(
            "NRRECSOLEMERGPROD" => $row["NRRECSOLEMERGPROD"]
        );
        
        $amount = $this->destinosSolicitacaoService->getDestinationRecipeAmoutByRelatedRecipe($selectParam);
        return $amount;
    }
    
    public function getDestinationRecipeAmoutByRelatedRecipeWithRowInstance(Row $row, Response $response){
        
        $row = $row->getRow()[0];
        $amount = self::getDestinationRecipeAmoutByRelatedRecipe($row);
        
        $response->addDataSet(new DataSet("destinationRecipeAmout", array($amount)));
    }
    
    public function updateRecipeAmount($row){
        
        $updateParams = array(
            "NRRECSOLEMERGPROD" => $row["NRRECSOLEMERGPROD"],
            "QTRECEITA"         => $row["QTDRECEITASUSADAS"]
        );
        
        $this->destinosSolicitacaoService->updateRecipeAmount($updateParams);
        
    }
    
}