<?php

namespace Teknisa\PCP\Controllers;

use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\Remote\FileUploader\Server;

class FluxprodrecController extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName = "fluxprodrec_classecia_setor_categoriaprod_categoriaprod_turno_turno_receitam";
	protected $dataSourceNameToSave  = "fluxprodrec";

	function __construct($crudService, ParameterBag $parameterBag) {
		parent::__construct($crudService, $parameterBag);
	}

	public function saveFluxprod(DTO\Request\Row $request, DTO\Response $response) {
		try {
			$row = $request->getRow();
			if ($row['IDABRANCIA'] != '4' && isset($row['NRVOO'])) {
				$row['NRVOO'] == null;
			}
			if ($row['IDABRANREC'] != '1' && isset($row['CDRECEITA'])) {
				$row['CDRECEITA'] == null;
			}
			//Validate duplicate register
			// $this->_validateDuplication();
			$dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
			$rows = $this->crudService->getRowsToSave($request, $dataSourceName);
			$this->crudService->save($dataSourceName, $rows);
		} catch (\Exception $e) {
			$msg = strpos($e->getMessage(), 'UN_FLUXPRODREC') ? "Impossível adicionar. Registro já existe." : $e->getMessage();
		}
	}

	private function _validateDuplication(){

		$conditions = _filterConditions($row);
        $filterCriteria = new FilterCriteria($this->dataSourceNameToSave, $conditions);

        $newFilterCriteria = $this->getPopulatedFilterCriteria($filterCriteria, array());

        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);

        if(current($dataSet->getRows())) {
            $errorMsg = "O valor informado para o campo de ".$field['description']." já foi cadastrado.";
            throw new \Exception($errorMsg, 1);
        }
	}

	// private function _filterConditions($row){
	// 	return array(
			
	// 	);
	// }
}