<?php
namespace Teknisa\PCP\Services;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;

class DestinosSolicitacaoCheckListEmergencialService {
    
    protected $connection;
    
    public function __construct($connection) {
        
        $this->connection = $connection;
        
    }
    
    public function getDestinationRecipeAmoutByRelatedRecipe($selectParam){
        
        $select = "SELECT NVL(SUM(QTRECEITA), 0) AS QTDTOTAL 
                   FROM DESTSOLEMERGPROD WHERE NRRECSOLEMERGPROD = :NRRECSOLEMERGPROD GROUP BY NRRECSOLEMERGPROD";
                   
            
        try{
            $std = $this->connection->prepare($select);
            $std->execute($selectParam);
            $amount = $std->fetchAll();
            
            if(!$amount){
                return 0;
            } else {
                return $amount[0]["QTDTOTAL"];
            }
            
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function updateRecipeAmount($updateParams){
        
        $insert = "UPDATE RECSOLEMERGPROD
                    SET QTRECEITA = :QTRECEITA
                    WHERE NRRECSOLEMERGPROD = :NRRECSOLEMERGPROD";
        
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($updateParams);
            
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
}